]> git.ipfire.org Git - thirdparty/git.git/blob - git-rebase.sh
merge-recursive: add ability to turn off directory rename detection
[thirdparty/git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=t
9 OPTIONS_SPEC="\
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
13 --
14 Available options are
15 v,verbose! display a diffstat of what changed upstream
16 q,quiet! be quiet. implies --no-stat
17 autostash automatically stash/stash pop before and after
18 fork-point use 'merge-base --fork-point' to refine upstream
19 onto=! rebase onto given branch instead of upstream
20 r,rebase-merges? try to rebase merges instead of skipping them
21 p,preserve-merges! try to recreate merges instead of ignoring them
22 s,strategy=! use the given merge strategy
23 X,strategy-option=! pass the argument through to the merge strategy
24 no-ff! cherry-pick all commits, even if unchanged
25 f,force-rebase! cherry-pick all commits, even if unchanged
26 m,merge! use merging strategies to rebase
27 i,interactive! let the user edit the list of commits to rebase
28 x,exec=! add exec lines after each commit of the editable list
29 k,keep-empty preserve empty commits during rebase
30 allow-empty-message allow rebasing commits with empty messages
31 stat! display a diffstat of what changed upstream
32 n,no-stat! do not show diffstat of what changed upstream
33 verify allow pre-rebase hook to run
34 rerere-autoupdate allow rerere to update index with resolved conflicts
35 root! rebase all reachable commits up to the root(s)
36 autosquash move commits that begin with squash!/fixup! under -i
37 signoff add a Signed-off-by: line to each commit
38 committer-date-is-author-date! passed to 'git am'
39 ignore-date! passed to 'git am'
40 whitespace=! passed to 'git apply'
41 ignore-whitespace! passed to 'git apply'
42 C=! passed to 'git apply'
43 S,gpg-sign? GPG-sign commits
44 Actions:
45 continue! continue
46 abort! abort and check out the original branch
47 skip! skip current patch and continue
48 edit-todo! edit the todo list during an interactive rebase
49 quit! abort but keep HEAD where it is
50 show-current-patch! show the patch file being applied or merged
51 "
52 . git-sh-setup
53 set_reflog_action rebase
54 require_work_tree_exists
55 cd_to_toplevel
56
57 LF='
58 '
59 ok_to_skip_pre_rebase=
60 resolvemsg="
61 $(gettext 'Resolve all conflicts manually, mark them as resolved with
62 "git add/rm <conflicted_files>", then run "git rebase --continue".
63 You can instead skip this commit: run "git rebase --skip".
64 To abort and get back to the state before "git rebase", run "git rebase --abort".')
65 "
66 squash_onto=
67 unset onto
68 unset restrict_revision
69 cmd=
70 strategy=
71 strategy_opts=
72 do_merge=
73 merge_dir="$GIT_DIR"/rebase-merge
74 apply_dir="$GIT_DIR"/rebase-apply
75 verbose=
76 diffstat=
77 test "$(git config --bool rebase.stat)" = true && diffstat=t
78 autostash="$(git config --bool rebase.autostash || echo false)"
79 fork_point=auto
80 git_am_opt=
81 git_format_patch_opt=
82 rebase_root=
83 force_rebase=
84 allow_rerere_autoupdate=
85 # Non-empty if a rebase was in progress when 'git rebase' was invoked
86 in_progress=
87 # One of {am, merge, interactive}
88 type=
89 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
90 state_dir=
91 # One of {'', continue, skip, abort}, as parsed from command line
92 action=
93 rebase_merges=
94 rebase_cousins=
95 preserve_merges=
96 autosquash=
97 keep_empty=
98 allow_empty_message=--allow-empty-message
99 signoff=
100 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
101 case "$(git config --bool commit.gpgsign)" in
102 true) gpg_sign_opt=-S ;;
103 *) gpg_sign_opt= ;;
104 esac
105
106 read_basic_state () {
107 test -f "$state_dir/head-name" &&
108 test -f "$state_dir/onto" &&
109 head_name=$(cat "$state_dir"/head-name) &&
110 onto=$(cat "$state_dir"/onto) &&
111 # We always write to orig-head, but interactive rebase used to write to
112 # head. Fall back to reading from head to cover for the case that the
113 # user upgraded git with an ongoing interactive rebase.
114 if test -f "$state_dir"/orig-head
115 then
116 orig_head=$(cat "$state_dir"/orig-head)
117 else
118 orig_head=$(cat "$state_dir"/head)
119 fi &&
120 GIT_QUIET=$(cat "$state_dir"/quiet) &&
121 test -f "$state_dir"/verbose && verbose=t
122 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
123 test -f "$state_dir"/strategy_opts &&
124 strategy_opts="$(cat "$state_dir"/strategy_opts)"
125 test -f "$state_dir"/allow_rerere_autoupdate &&
126 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
127 test -f "$state_dir"/gpg_sign_opt &&
128 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
129 test -f "$state_dir"/signoff && {
130 signoff="$(cat "$state_dir"/signoff)"
131 force_rebase=t
132 }
133 }
134
135 write_basic_state () {
136 echo "$head_name" > "$state_dir"/head-name &&
137 echo "$onto" > "$state_dir"/onto &&
138 echo "$orig_head" > "$state_dir"/orig-head &&
139 echo "$GIT_QUIET" > "$state_dir"/quiet &&
140 test t = "$verbose" && : > "$state_dir"/verbose
141 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
142 test -n "$strategy_opts" && echo "$strategy_opts" > \
143 "$state_dir"/strategy_opts
144 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
145 "$state_dir"/allow_rerere_autoupdate
146 test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
147 test -n "$signoff" && echo "$signoff" >"$state_dir"/signoff
148 }
149
150 output () {
151 case "$verbose" in
152 '')
153 output=$("$@" 2>&1 )
154 status=$?
155 test $status != 0 && printf "%s\n" "$output"
156 return $status
157 ;;
158 *)
159 "$@"
160 ;;
161 esac
162 }
163
164 move_to_original_branch () {
165 case "$head_name" in
166 refs/*)
167 message="rebase finished: $head_name onto $onto"
168 git update-ref -m "$message" \
169 $head_name $(git rev-parse HEAD) $orig_head &&
170 git symbolic-ref \
171 -m "rebase finished: returning to $head_name" \
172 HEAD $head_name ||
173 die "$(eval_gettext "Could not move back to \$head_name")"
174 ;;
175 esac
176 }
177
178 apply_autostash () {
179 if test -f "$state_dir/autostash"
180 then
181 stash_sha1=$(cat "$state_dir/autostash")
182 if git stash apply $stash_sha1 >/dev/null 2>&1
183 then
184 echo "$(gettext 'Applied autostash.')" >&2
185 else
186 git stash store -m "autostash" -q $stash_sha1 ||
187 die "$(eval_gettext "Cannot store \$stash_sha1")"
188 gettext 'Applying autostash resulted in conflicts.
189 Your changes are safe in the stash.
190 You can run "git stash pop" or "git stash drop" at any time.
191 ' >&2
192 fi
193 fi
194 }
195
196 finish_rebase () {
197 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
198 apply_autostash &&
199 { git gc --auto || true; } &&
200 rm -rf "$state_dir"
201 }
202
203 run_specific_rebase () {
204 if [ "$interactive_rebase" = implied ]; then
205 GIT_EDITOR=:
206 export GIT_EDITOR
207 autosquash=
208 fi
209 . git-rebase--$type
210 git_rebase__$type${preserve_merges:+__preserve_merges}
211 ret=$?
212 if test $ret -eq 0
213 then
214 finish_rebase
215 elif test $ret -eq 2 # special exit status for rebase -i
216 then
217 apply_autostash &&
218 rm -rf "$state_dir" &&
219 die "Nothing to do"
220 fi
221 exit $ret
222 }
223
224 run_pre_rebase_hook () {
225 if test -z "$ok_to_skip_pre_rebase" &&
226 test -x "$(git rev-parse --git-path hooks/pre-rebase)"
227 then
228 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
229 die "$(gettext "The pre-rebase hook refused to rebase.")"
230 fi
231 }
232
233 test -f "$apply_dir"/applying &&
234 die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
235
236 if test -d "$apply_dir"
237 then
238 type=am
239 state_dir="$apply_dir"
240 elif test -d "$merge_dir"
241 then
242 if test -f "$merge_dir"/interactive
243 then
244 type=interactive
245 interactive_rebase=explicit
246 else
247 type=merge
248 fi
249 state_dir="$merge_dir"
250 fi
251 test -n "$type" && in_progress=t
252
253 total_argc=$#
254 while test $# != 0
255 do
256 case "$1" in
257 --no-verify)
258 ok_to_skip_pre_rebase=yes
259 ;;
260 --verify)
261 ok_to_skip_pre_rebase=
262 ;;
263 --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
264 test $total_argc -eq 2 || usage
265 action=${1##--}
266 ;;
267 --onto=*)
268 onto="${1#--onto=}"
269 ;;
270 --exec=*)
271 cmd="${cmd}exec ${1#--exec=}${LF}"
272 test -z "$interactive_rebase" && interactive_rebase=implied
273 ;;
274 --interactive)
275 interactive_rebase=explicit
276 ;;
277 --keep-empty)
278 keep_empty=yes
279 ;;
280 --allow-empty-message)
281 allow_empty_message=--allow-empty-message
282 ;;
283 --no-keep-empty)
284 keep_empty=
285 ;;
286 --rebase-merges)
287 rebase_merges=t
288 test -z "$interactive_rebase" && interactive_rebase=implied
289 ;;
290 --rebase-merges=*)
291 rebase_merges=t
292 case "${1#*=}" in
293 rebase-cousins) rebase_cousins=t;;
294 no-rebase-cousins) rebase_cousins=;;
295 *) die "Unknown mode: $1";;
296 esac
297 test -z "$interactive_rebase" && interactive_rebase=implied
298 ;;
299 --preserve-merges)
300 preserve_merges=t
301 test -z "$interactive_rebase" && interactive_rebase=implied
302 ;;
303 --autosquash)
304 autosquash=t
305 ;;
306 --no-autosquash)
307 autosquash=
308 ;;
309 --fork-point)
310 fork_point=t
311 ;;
312 --no-fork-point)
313 fork_point=
314 ;;
315 --merge)
316 do_merge=t
317 ;;
318 --strategy-option=*)
319 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
320 do_merge=t
321 test -z "$strategy" && strategy=recursive
322 ;;
323 --strategy=*)
324 strategy="${1#--strategy=}"
325 do_merge=t
326 ;;
327 --no-stat)
328 diffstat=
329 ;;
330 --stat)
331 diffstat=t
332 ;;
333 --autostash)
334 autostash=true
335 ;;
336 --no-autostash)
337 autostash=false
338 ;;
339 --verbose)
340 verbose=t
341 diffstat=t
342 GIT_QUIET=
343 ;;
344 --quiet)
345 GIT_QUIET=t
346 git_am_opt="$git_am_opt -q"
347 verbose=
348 diffstat=
349 ;;
350 --whitespace=*)
351 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
352 case "${1#--whitespace=}" in
353 fix|strip)
354 force_rebase=t
355 ;;
356 esac
357 ;;
358 --ignore-whitespace)
359 git_am_opt="$git_am_opt $1"
360 ;;
361 --signoff)
362 signoff=--signoff
363 ;;
364 --no-signoff)
365 signoff=
366 ;;
367 --committer-date-is-author-date|--ignore-date)
368 git_am_opt="$git_am_opt $1"
369 force_rebase=t
370 ;;
371 -C*)
372 git_am_opt="$git_am_opt $1"
373 ;;
374 --root)
375 rebase_root=t
376 ;;
377 --force-rebase|--no-ff)
378 force_rebase=t
379 ;;
380 --rerere-autoupdate|--no-rerere-autoupdate)
381 allow_rerere_autoupdate="$1"
382 ;;
383 --gpg-sign)
384 gpg_sign_opt=-S
385 ;;
386 --gpg-sign=*)
387 gpg_sign_opt="-S${1#--gpg-sign=}"
388 ;;
389 --)
390 shift
391 break
392 ;;
393 *)
394 usage
395 ;;
396 esac
397 shift
398 done
399 test $# -gt 2 && usage
400
401 if test -n "$action"
402 then
403 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
404 # Only interactive rebase uses detailed reflog messages
405 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
406 then
407 GIT_REFLOG_ACTION="rebase -i ($action)"
408 export GIT_REFLOG_ACTION
409 fi
410 fi
411
412 if test "$action" = "edit-todo" && test "$type" != "interactive"
413 then
414 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
415 fi
416
417 case "$action" in
418 continue)
419 # Sanity check
420 git rev-parse --verify HEAD >/dev/null ||
421 die "$(gettext "Cannot read HEAD")"
422 git update-index --ignore-submodules --refresh &&
423 git diff-files --quiet --ignore-submodules || {
424 echo "$(gettext "You must edit all merge conflicts and then
425 mark them as resolved using git add")"
426 exit 1
427 }
428 read_basic_state
429 run_specific_rebase
430 ;;
431 skip)
432 output git reset --hard HEAD || exit $?
433 read_basic_state
434 run_specific_rebase
435 ;;
436 abort)
437 git rerere clear
438 read_basic_state
439 case "$head_name" in
440 refs/*)
441 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
442 die "$(eval_gettext "Could not move back to \$head_name")"
443 ;;
444 esac
445 output git reset --hard $orig_head
446 finish_rebase
447 exit
448 ;;
449 quit)
450 exec rm -rf "$state_dir"
451 ;;
452 edit-todo)
453 run_specific_rebase
454 ;;
455 show-current-patch)
456 run_specific_rebase
457 die "BUG: run_specific_rebase is not supposed to return here"
458 ;;
459 esac
460
461 # Make sure no rebase is in progress
462 if test -n "$in_progress"
463 then
464 state_dir_base=${state_dir##*/}
465 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
466 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
467 die "
468 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
469 I wonder if you are in the middle of another rebase. If that is the
470 case, please try
471 $cmd_live_rebase
472 If that is not the case, please
473 $cmd_clear_stale_rebase
474 and run me again. I am stopping in case you still have something
475 valuable there.')"
476 fi
477
478 if test -n "$rebase_root" && test -z "$onto"
479 then
480 test -z "$interactive_rebase" && interactive_rebase=implied
481 fi
482
483 if test -n "$keep_empty"
484 then
485 test -z "$interactive_rebase" && interactive_rebase=implied
486 fi
487
488 if test -n "$interactive_rebase"
489 then
490 type=interactive
491 state_dir="$merge_dir"
492 elif test -n "$do_merge"
493 then
494 type=merge
495 state_dir="$merge_dir"
496 else
497 type=am
498 state_dir="$apply_dir"
499 fi
500
501 if test -t 2 && test -z "$GIT_QUIET"
502 then
503 git_format_patch_opt="$git_format_patch_opt --progress"
504 fi
505
506 if test -n "$git_am_opt"; then
507 incompatible_opts=$(echo " $git_am_opt " | \
508 sed -e 's/ -q / /g' -e 's/^ \(.*\) $/\1/')
509 if test -n "$interactive_rebase"
510 then
511 if test -n "$incompatible_opts"
512 then
513 die "$(gettext "error: cannot combine interactive options (--interactive, --exec, --rebase-merges, --preserve-merges, --keep-empty, --root + --onto) with am options ($incompatible_opts)")"
514 fi
515 fi
516 if test -n "$do_merge"; then
517 if test -n "$incompatible_opts"
518 then
519 die "$(gettext "error: cannot combine merge options (--merge, --strategy, --strategy-option) with am options ($incompatible_opts)")"
520 fi
521 fi
522 fi
523
524 if test -n "$signoff"
525 then
526 test -n "$preserve_merges" &&
527 die "$(gettext "error: cannot combine '--signoff' with '--preserve-merges'")"
528 git_am_opt="$git_am_opt $signoff"
529 force_rebase=t
530 fi
531
532 if test -n "$preserve_merges"
533 then
534 # Note: incompatibility with --signoff handled in signoff block above
535 # Note: incompatibility with --interactive is just a strong warning;
536 # git-rebase.txt caveats with "unless you know what you are doing"
537 test -n "$rebase_merges" &&
538 die "$(gettext "error: cannot combine '--preserve_merges' with '--rebase-merges'")"
539 fi
540
541 if test -n "$rebase_merges"
542 then
543 test -n "$strategy_opts" &&
544 die "$(gettext "error: cannot combine '--rebase_merges' with '--strategy-option'")"
545 test -n "$strategy" &&
546 die "$(gettext "error: cannot combine '--rebase_merges' with '--strategy'")"
547 fi
548
549 if test -z "$rebase_root"
550 then
551 case "$#" in
552 0)
553 if ! upstream_name=$(git rev-parse --symbolic-full-name \
554 --verify -q @{upstream} 2>/dev/null)
555 then
556 . git-parse-remote
557 error_on_missing_default_upstream "rebase" "rebase" \
558 "against" "git rebase $(gettext '<branch>')"
559 fi
560
561 test "$fork_point" = auto && fork_point=t
562 ;;
563 *) upstream_name="$1"
564 if test "$upstream_name" = "-"
565 then
566 upstream_name="@{-1}"
567 fi
568 shift
569 ;;
570 esac
571 upstream=$(peel_committish "${upstream_name}") ||
572 die "$(eval_gettext "invalid upstream '\$upstream_name'")"
573 upstream_arg="$upstream_name"
574 else
575 if test -z "$onto"
576 then
577 empty_tree=$(git hash-object -t tree /dev/null)
578 onto=$(git commit-tree $empty_tree </dev/null)
579 squash_onto="$onto"
580 fi
581 unset upstream_name
582 unset upstream
583 test $# -gt 1 && usage
584 upstream_arg=--root
585 fi
586
587 # Make sure the branch to rebase onto is valid.
588 onto_name=${onto-"$upstream_name"}
589 case "$onto_name" in
590 *...*)
591 if left=${onto_name%...*} right=${onto_name#*...} &&
592 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
593 then
594 case "$onto" in
595 ?*"$LF"?*)
596 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
597 ;;
598 '')
599 die "$(eval_gettext "\$onto_name: there is no merge base")"
600 ;;
601 esac
602 else
603 die "$(eval_gettext "\$onto_name: there is no merge base")"
604 fi
605 ;;
606 *)
607 onto=$(peel_committish "$onto_name") ||
608 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
609 ;;
610 esac
611
612 # If the branch to rebase is given, that is the branch we will rebase
613 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
614 # $orig_head -- commit object name of tip of the branch before rebasing
615 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
616 switch_to=
617 case "$#" in
618 1)
619 # Is it "rebase other $branchname" or "rebase other $commit"?
620 branch_name="$1"
621 switch_to="$1"
622
623 # Is it a local branch?
624 if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
625 orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
626 then
627 head_name="refs/heads/$branch_name"
628 # If not is it a valid ref (branch or commit)?
629 elif orig_head=$(git rev-parse -q --verify "$branch_name")
630 then
631 head_name="detached HEAD"
632
633 else
634 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
635 fi
636 ;;
637 0)
638 # Do not need to switch branches, we are already on it.
639 if branch_name=$(git symbolic-ref -q HEAD)
640 then
641 head_name=$branch_name
642 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
643 else
644 head_name="detached HEAD"
645 branch_name=HEAD
646 fi
647 orig_head=$(git rev-parse --verify HEAD) || exit
648 ;;
649 *)
650 die "BUG: unexpected number of arguments left to parse"
651 ;;
652 esac
653
654 if test "$fork_point" = t
655 then
656 new_upstream=$(git merge-base --fork-point "$upstream_name" \
657 "${switch_to:-HEAD}")
658 if test -n "$new_upstream"
659 then
660 restrict_revision=$new_upstream
661 fi
662 fi
663
664 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
665 then
666 stash_sha1=$(git stash create "autostash") ||
667 die "$(gettext 'Cannot autostash')"
668
669 mkdir -p "$state_dir" &&
670 echo $stash_sha1 >"$state_dir/autostash" &&
671 stash_abbrev=$(git rev-parse --short $stash_sha1) &&
672 echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
673 git reset --hard
674 fi
675
676 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
677
678 # Now we are rebasing commits $upstream..$orig_head (or with --root,
679 # everything leading up to $orig_head) on top of $onto
680
681 # Check if we are already based on $onto with linear history,
682 # but this should be done only when upstream and onto are the same
683 # and if this is not an interactive rebase.
684 mb=$(git merge-base "$onto" "$orig_head")
685 if test "$type" != interactive && test "$upstream" = "$onto" &&
686 test "$mb" = "$onto" && test -z "$restrict_revision" &&
687 # linear history?
688 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
689 then
690 if test -z "$force_rebase"
691 then
692 # Lazily switch to the target branch if needed...
693 test -z "$switch_to" ||
694 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
695 git checkout -q "$switch_to" --
696 if test "$branch_name" = "HEAD" &&
697 ! git symbolic-ref -q HEAD
698 then
699 say "$(eval_gettext "HEAD is up to date.")"
700 else
701 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
702 fi
703 finish_rebase
704 exit 0
705 else
706 if test "$branch_name" = "HEAD" &&
707 ! git symbolic-ref -q HEAD
708 then
709 say "$(eval_gettext "HEAD is up to date, rebase forced.")"
710 else
711 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
712 fi
713 fi
714 fi
715
716 # If a hook exists, give it a chance to interrupt
717 run_pre_rebase_hook "$upstream_arg" "$@"
718
719 if test -n "$diffstat"
720 then
721 if test -n "$verbose"
722 then
723 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
724 fi
725 # We want color (if set), but no pager
726 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
727 fi
728
729 test "$type" = interactive && run_specific_rebase
730
731 # Detach HEAD and reset the tree
732 say "$(gettext "First, rewinding head to replay your work on top of it...")"
733
734 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
735 git checkout -q "$onto^0" || die "could not detach HEAD"
736 git update-ref ORIG_HEAD $orig_head
737
738 # If the $onto is a proper descendant of the tip of the branch, then
739 # we just fast-forwarded.
740 if test "$mb" = "$orig_head"
741 then
742 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
743 move_to_original_branch
744 finish_rebase
745 exit 0
746 fi
747
748 if test -n "$rebase_root"
749 then
750 revisions="$onto..$orig_head"
751 else
752 revisions="${restrict_revision-$upstream}..$orig_head"
753 fi
754
755 run_specific_rebase